#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    cin >> n;
    int a[n];
    for(int i = 0; i < n; ++i) cin >> a[i];
    int k;
    cin >> k;
    int r[n];
    bool prvi = false;
    bool izbrisao = false;
    for(int i = 0; i < n; ++i)
    {
        if(i == 0)
        {
            if(a[i] > a[i + 1])
            {
                a[i] = -1;
                r[i] = 1;
                prvi = true;
            }
            else r[i] = 0;
        }
        else if(prvi)
        {
            r[i] = 0;
            prvi = false;
        }
        else if(izbrisao)
        {
            int j = i - 1;
            while(a[j] == -1) --j;
            if(a[i] < a[j])
            {
                izbrisao = true;
                a[i] = -1;
                r[i] = r[i - 1] + 1;
            }
            else
            {
                r[i] = r[i - 1];
                izbrisao = false;
            }
        }
        else if(a[i] < a[i - 1])
        {
            izbrisao = true;
            a[i] = -1;
            r[i] = r[i - 1] + 1;
            prvi = false;
        }
        else r[i] = r[i - 1];
        //cout << r[i] << " ";
    }
    for(int i = 0; i < k; ++i)
    {
        int l, d;
        cin >> l >> d;
        --l; --d;
        if(r[d] - r[l] <= 1) cout << "DA" << endl;
        else cout << "NE" << endl;
    }
    return 0;
}
/*
10
2 3 1 2 4 5 1 7 8 1
1
*/